/*	
 *	clipnet.c
 *
 *	lbg[N֘ÃT|[g[`
 *
 *	CLiP - Common Library for P/ECE
 *	Copyright (C) 2001-2005 Naoyuki Sawa
 *
 *	* Sun Jul 24 04:08:00 JST 2005 Naoyuki Sawa
 *	- 쐬JnB
 *	* Tue Aug 02 06:25:00 JST 2005 Naoyuki Sawa
 *	- update_internet_checksum()Aip_unpack_header()Aip_pack_header()ǉ܂B
 *	* Sun Aug 07 04:10:00 JST 2005 Naoyuki Sawa
 *	- ip_pack_header()Aip_unpack_header()pack_ip_header()Aunpack_ip_header()ɉ܂B
 */
#include "clip.h"

/****************************************************************************
 *	
 ****************************************************************************/

int
internet_checksum(const void* _data, int size)
{
	const unsigned char* data = _data;
	int sum = 0;

			//////////////////////////////////////////////////////////////////
			// ƂāAől̃P[X̉Zg[Xlq܂B	//
	 		//////////////////////////	-------	-------	-------		//
				                //	  sum	data[0]	data[1]		//
	 					//	-------	-------	-------		//
	while(size) {				//	0FFFF	  FF__	  __FF		//
		sum += *data++ << 8;		//	1FEFF <---+	    |		//
		size--;				//					//
		if(size) {			//			    |		//
			sum += *data++;		//	1FFFE <-------------+		//
			size--;			//					//
		}				//	+-------+			//
		sum += sum >> 16;		//	1FFFF <-+			//
		sum = (unsigned short)sum;	//	0FFFF				//
	}					//////////////////////////////////////////

	return (unsigned short)~sum;
}

void
update_internet_checksum(void* _data, int size, int sum_ofs)
{
	unsigned char* data = _data;
	//
	int sum;

	if((sum_ofs < 0) ||
	   (sum_ofs > size - 2)) {
		DIE();
	}

	/* `FbNTvŹA`FbNTtB[h0ƂĂ܂B */
	PUT_BEHALF(data+sum_ofs, 0);

	/* `FbNTvZ܂B */
	sum = internet_checksum(data, size);

	/* `FbNTmF܂B
	 * * PUT_BEHALF()͈x]̂ŁA
	 *	PUT_BEHALF(data+sum_ofs, internet_checksum(data, size));
	 *   ƂĂ͂܂!!
	 */
	PUT_BEHALF(data+sum_ofs, sum);
}

int
unpack_ip_header(IPHEADER* header, const void* _buffer, int buffer_length)
{
	const unsigned char* buffer = _buffer;
	//
	int version;
	int header_length;
	int type_of_service;
	int total_length;
	int identification;
	int flags;
	int fragment_offset;
	int time_to_live;
	int protocol;
	int header_checksum;
	int source_ip_address;
	int destination_ip_address;

	/* ŏwb_20oCgłB */
	if(buffer_length < 20) {
		return -1;
	}

	/* tB[hlo܂B */
	version			= (BEHALF(buffer+ 0) & 0xf000) >> 12;
	header_length		= (BEHALF(buffer+ 0) & 0x0f00) >>  6;
	type_of_service		=  BEHALF(buffer+ 0) & 0x00ff;
	total_length		=  BEHALF(buffer+ 2);
	identification		=  BEHALF(buffer+ 4);
	flags			= (BEHALF(buffer+ 6) & 0xe000) >> 13;
	fragment_offset		= (BEHALF(buffer+ 6) & 0x1fff) <<  3;
	time_to_live		= (BEHALF(buffer+ 8) & 0xff00) >>  8;
	protocol		=  BEHALF(buffer+ 8) & 0x00ff;
	header_checksum		=  BEHALF(buffer+10);
	source_ip_address	=  BEWORD(buffer+12);
	destination_ip_address	=  BEWORD(buffer+16);

	/* tB[hl܂B */
	if(version != 4) {
		return -1;
	}
	if(header_length < 20) {
		return -1;
	}
	if((total_length < header_length) ||
	   (total_length > buffer_length)) {
		return -1;
	}
	if(internet_checksum(buffer, header_length) != 0) {
		return -1;
	}

	/* IPHEADER\̂ցAtB[hli[܂B */
	header->identification		= identification;
	header->flags			= flags;
	header->fragment_offset		= fragment_offset;
	header->protocol		= protocol;
	header->source_ip_address	= source_ip_address;
	header->destination_ip_address	= destination_ip_address;
	//
	header->data			= (unsigned char*)buffer + header_length;
	header->data_length		= total_length           - header_length;

	return total_length;
}

int
pack_ip_header(const IPHEADER* header, void* _buffer, int buffer_length)
{
	unsigned char* buffer = _buffer;
	//
	int version;
	int header_length;
	int type_of_service;
	int total_length;
	int identification;
	int flags;
	int fragment_offset;
	int time_to_live;
	int protocol;
	//int header_checksum;
	int source_ip_address;
	int destination_ip_address;

	/* tB[hl肵܂B */
	version			= 4;
	header_length		= 20;
	type_of_service		= 0;
	total_length		= 20 + header->data_length;
	identification		= header->identification;
	flags			= header->flags;
	fragment_offset		= header->fragment_offset;
	time_to_live		= 255;
	protocol		= header->protocol;
	//header_checksum	= g܂
	source_ip_address	= header->source_ip_address;
	destination_ip_address	= header->destination_ip_address;

	/* tB[hl܂B */
	if((total_length < 0) ||
	   (total_length > buffer_length)) {
		return -1;
	}
	if(fragment_offset & 7) {
		return -1;
	}

	/* wb_i[ʒuƃRs[f[^I[o[bvĂ\̂ŁA
	 * ɁARs[f[^obt@̃f[^i[ʒuփRs[Ă܂B
	 */
	memmove(buffer+20, header->data, header->data_length);

	/* obt@̃wb_i[ʒuցAtB[hli[܂B */
	PUT_BEHALF(buffer+ 0, version<<12 | header_length<<6 | type_of_service);
	PUT_BEHALF(buffer+ 2, total_length);
	PUT_BEHALF(buffer+ 4, identification);
	PUT_BEHALF(buffer+ 6, flags<<13 | fragment_offset>>3);
	PUT_BEHALF(buffer+ 8, time_to_live<<8 | protocol);
	//PUT_BEHALF(buffer+10, ƂŌvZ܂);
	PUT_BEWORD(buffer+12, source_ip_address);
	PUT_BEWORD(buffer+16, destination_ip_address);

	/* wb_`FbNTi[܂B */
	update_internet_checksum(buffer, 20, 10);

	return total_length;
}
